Bug 1214840 - Review Request: python-statsd - Python client for the statsd daemon
Summary: Review Request: python-statsd - Python client for the statsd daemon
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Michael S.
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1414530
TreeView+ depends on / blocked
 
Reported: 2015-04-23 16:06 UTC by Tristan Cacqueray
Modified: 2017-01-18 18:41 UTC (History)
4 users (show)

Fixed In Version: python-statsd-2.1.2-2.fc22
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1414530 (view as bug list)
Environment:
Last Closed: 2015-05-12 20:48:31 UTC
misc: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Tristan Cacqueray 2015-04-23 16:06:14 UTC
Spec URL: https://ca.enocloud.com:8080/v1/AUTH_09317026f6ce4da881c5e0b69bdcff93/fedora-pkg/python-statsd.spec
SRPM URL: https://ca.enocloud.com:8080/v1/AUTH_09317026f6ce4da881c5e0b69bdcff93/fedora-pkg/python-statsd-2.1.2-1.fc21.src.rpm
Description: python-statsd implements a Python client for the statsd daemon.
Fedora Account System Username: tdecacqu

Comment 1 Tristan Cacqueray 2015-04-23 16:11:39 UTC
Oh, forgot to mention this my first package!

Comment 2 Tristan Cacqueray 2015-04-23 16:50:58 UTC
And the koji build result: https://koji.fedoraproject.org/koji/taskinfo?taskID=9551068

Comment 3 Alexander Ploumistos 2015-04-23 20:16:43 UTC
Hello and welcome aboard,

This is an informal review, so you'll have to wait for another packager to approve this. Going over the items on fedora-review's checklist, here's what I've found:

* I'm not sure how this is supposed to work, but I think you need to specify "BuildRequires: python2-devel" or "BuildRequires: python3-devel". See 
http://fedoraproject.org/wiki/Packaging:Python#BuildRequires

* License files have been included in all rpms, even though fedora-review complains (Cannot find LICENSE in rpm(s)), perhaps this warrants a bug report against fedora-review.

* There were 4 warnings from rpmlint:
python-statsd-doc.noarch: W: summary-ended-with-dot C Documentation of the Python client for the statsd daemon.
python-statsd-doc.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/python-statsd-doc/html/objects.inv
python-statsd-doc.noarch: W: file-not-utf8 /usr/share/doc/python-statsd-doc/html/objects.inv
python-statsd-doc.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/python-statsd-doc/html/_static/jquery.js

The first one can be fixed easily, just remove the full stop at the end of the summary sentence. I don't think the others are worth bothering with, however, in the line where you clean up after sphinx-build, you could also remove objects.inv (I couldn't find anything that needs it).


The following are from the "Python" section of the checklist:
[x]: Python eggs must not download any dependencies during the build process.
- I checked the mock build logs and nothing was downloaded during the build process.

[x]: A package which is used by another package via an egg interface should provide egg info.
- I found no such case.

[!]: Package meets the Packaging Guidelines::Python
- I'm fairly confident that this was not given a "pass" from the script because you need to specify the BR i mentioned earlier to be in compliance with the guidelines. All the other Python-related stuff seem to be in order.


These here are not mandatory, they are on the "SHOULD" items list:
[!]: Package has no %clean section with rm -rf %{buildroot} (or $RPM_BUILD_ROOT)
- For some time now, rpm handles this internally and you don't really need to have a %clean section (not on Fedora at least).

[!]: Latest version is packaged.
- It's not. Is there a particular reason for that?

[!]: %check is present and all tests pass.
- Can't that be done with the included tests.py file?

[x]: Packages should try to preserve timestamps of original installed files.
- According to the build log, every file that is copied has the same timestamp as in the source tarball.



I have confirmed that all the other items on the list are OK. Please let me know if you think I am wrong about something, after all I'm learning from this.

Comment 4 Tristan Cacqueray 2015-04-23 21:04:56 UTC
Hi Alexander, thanks for the extensive and fast feedback!

1/ The BR for python2-devel must have been pulled by one of the other BR, I've explicitly added none the less to the new version.

2/ I'm investigating the fedora-review output.

3/ rpmlint now only complain about wrong-file-end-of-line-encoding on jquery..

4/ Not sure what to do about the eggs comments.

5/ I removed the %clean directive

6/ This is not the latest version because it's not in the requirements of openstack-infra tools (which have statsd>=1.0.0,<3.0)

7/ I added the %check directive

Here is the new koji task:
 http://koji.fedoraproject.org/koji/taskinfo?taskID=9553470

And the spec and srpm url have been updated.

Comment 5 Alexander Ploumistos 2015-04-23 21:32:39 UTC
(In reply to Tristan Cacqueray from comment #4)
> 4/ Not sure what to do about the eggs comments.

They were among the items that required manual review, I just felt I should mention that everything was in order, so you are not to do anything about them, I was thinking out loud :)


> 6/ This is not the latest version because it's not in the requirements of
> openstack-infra tools (which have statsd>=1.0.0,<3.0)

You know a lot more about it than I do, so I'll take your word for it.
 

> And the spec and srpm url have been updated.

I think that you were supposed to increment the Release tag in your spec file and document the alterations you've made in the changelog. Leave it as it is for now and wait for one of the packagers to chime in.


I ran fedora-review on the updated files, checked all the logs and I saw that the tests were successful. As far as I can tell, the package is ready for approval.

Good job!

Comment 6 Michael S. 2015-04-28 17:56:32 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


So, after review, and based on the existing work done by Alexande:

- the version is not the latest, but given the reason to package, it is ok. I guess
it will be updated when the openstack requirement are updated ( I would
imagine sooner than later as this likely mean headaches down the road for you otherwise )

- I am not sure the semantic of %license, but it should only include the license
file. So CHANGES and AUTHORS should IMHO be left out.

- Since the doc include jquery and there is a ongoing effort to unbundle it, 
a provides should be added :
https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries

So just adding "Provides: bundled(jquery) " to the -dc subpackage should be enough for me.

- last, fedora-review complain on the requires between doc and the main package :

[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in python-
     statsd-doc

That's nitpicking, but I guess the tool is right, so if you could fix that before sending the package that would be nice.

So anyway, the package is good to go, welcome on board.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 5 files have unknown license. Detailed output of
     licensecheck in /home/misc/checkout/git/FedoraReview/1214840-python-
     statsd/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/licenses
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/licenses
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in python-
     statsd-doc
[x]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-statsd-2.1.2-1.el7.centos.noarch.rpm
          python-statsd-doc-2.1.2-1.el7.centos.noarch.rpm
          python-statsd-2.1.2-1.el7.centos.src.rpm
python-statsd.noarch: W: incoherent-version-in-changelog 2.1.2-1.fc21 ['2.1.2-1.el7.centos', '2.1.2-1.centos']
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
python-statsd.noarch: W: incoherent-version-in-changelog 2.1.2-1.fc21 ['2.1.2-1.el7.centos', '2.1.2-1.centos']
2 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
python-statsd-doc (rpmlib, GLIBC filtered):

python-statsd (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python-statsd-doc:
    python-statsd-doc

python-statsd:
    python-statsd



Source checksums
----------------
https://pypi.python.org/packages/source/s/statsd/statsd-2.1.2.tar.gz :
  CHECKSUM(SHA256) this package     : 45db168312a6820fd78697c7b6fd0196f3af922c8ebc88540edd0d6fafed554d
  CHECKSUM(SHA256) upstream package : 45db168312a6820fd78697c7b6fd0196f3af922c8ebc88540edd0d6fafed554d


Generated by fedora-review 0.5.2 (18d98aa) last change: 2014-10-14
Command line :./try-fedora-review -b 1214840
Buildroot used: epel-7-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 7 Alexander Ploumistos 2015-04-28 18:50:17 UTC
(In reply to Michael Scherer from comment #6)
> - I am not sure the semantic of %license, but it should only include the
> license
> file. So CHANGES and AUTHORS should IMHO be left out.

I did some research during my review and I tried to find packages with licenses, changelogs and authors in separate files. After randomly downloading ~30 srpms from koji, I found a couple that contained all three (can't remember which) and they had COPYING and AUTHORS in %license and CHANGES and README in the %doc section, which seemed reasonable, but others do not follow that reasoning. Also, many upstream projects provide author information in source headers, so this does not come up very often. Would it be an issue if the files were indeed included but separated in %doc and %license sections?


> - Since the doc include jquery and there is a ongoing effort to unbundle it, 
> a provides should be added :
> https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries
> 
> So just adding "Provides: bundled(jquery) " to the -dc subpackage should be
> enough for me.

<facepalm /> I looked at the sphinx html source, but it never occurred to me to consider jquery as a bundled library, will keep it in mind for the future. But why is the "Provides" necessary? Doesn't that imply that if another package requires jquery, it can use the one provided by the package? Do we want that?


> - last, fedora-review complain on the requires between doc and the main
> package :
> 
> [!]: Fully versioned dependency in subpackages if applicable.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in python-
>      statsd-doc
> 
> That's nitpicking, but I guess the tool is right, so if you could fix that
> before sending the package that would be nice.

Could you please elaborate a bit how this applies here?

Comment 8 Tristan Cacqueray 2015-04-28 19:22:06 UTC
Thanks misc, bellow is the spec diff.

Alexander, well I removed the un-necessary files in %license and also added the Requires %{name}... for the -doc package. I guess the reasoning is to make sure the user has the package along its documentation...

Spec URL: https://ca.enocloud.com:8080/v1/AUTH_09317026f6ce4da881c5e0b69bdcff93/fedora-pkg/python-statsd.spec
SRPM URL: https://ca.enocloud.com:8080/v1/AUTH_09317026f6ce4da881c5e0b69bdcff93/fedora-pkg/python-statsd-2.1.2-2.fc21.src.rpm

koji URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=9589625


diff --git a/python-statsd.spec b/python-statsd.spec
index efb25ec..a581b3b 100644
--- a/python-statsd.spec
+++ b/python-statsd.spec
@@ -4,7 +4,7 @@
 
 Name:       python-%{pypi_name}
 Version:    2.1.2
-Release:    1%{?dist}
+Release:    2%{?dist}
 Summary:    A Python statsd client
 
 License:    MIT
@@ -24,6 +24,8 @@ python-statsd implements a Python client for the statsd daemon.
 %package doc
 Summary:    Documentation of the Python client for the statsd daemon
 
+Provides:       bundled(jquery) = 1.1.14
+Requires:       %{name}%{?_isa} = %{version}-%{release}
 BuildRequires:  python-sphinx
 
 %description doc
@@ -55,7 +57,7 @@ rm -rf html/.{doctrees,buildinfo} html/objects.inv
 
 %files
 %doc README.rst
-%license LICENSE CHANGES AUTHORS
+%license LICENSE
 %{python_sitelib}/%{pypi_name}
 %{python_sitelib}/%{pypi_name}-*egg-info
 
@@ -64,5 +66,8 @@ rm -rf html/.{doctrees,buildinfo} html/objects.inv
 %license LICENSE
 
 %changelog
+* Tue Apr 28 2015 Tristan de Cacqueray <tdecacqu@redhat.com> - 2.1.2-2.fc21
+- Fixed fedora-review warnings
+
 * Thu Apr 23 2015 Tristan de Cacqueray <tdecacqu@redhat.com> - 2.1.2-1.fc21
 - Initial packaging

Comment 9 Tristan Cacqueray 2015-04-28 19:37:31 UTC
New Package SCM Request
=======================
Package Name: python-statsd
Short Description: A Python statsd client
Upstream URL: https://github.com/jsocol/pystatsd
Owners: tdecacqu
Branches: f20 f21 f22
InitialCC: misc

Comment 10 Gwyn Ciesla 2015-04-28 20:03:02 UTC
WARNING: fedora-review flag not set

Comment 11 Michael S. 2015-04-28 20:12:03 UTC
To answer Alex
> Could you please elaborate a bit how this applies here?

Not much, that's just one of the rule that I never fully understood and decided to just follow fedora-review. The idea is to make sure the right doc is pulled on multiarch, etc, but in practice, I am not sure that's a problem except in some corner case ( or maybe I am wrong )


And sorry Tristan, My bad, forgot to set the flag

Comment 12 Michael S. 2015-04-28 20:22:02 UTC
Also, ( as I am really not awake, I forgot half of the answer ), nothing should requires the bundled(jquery). It is used mostly for tracking where jquery is bundled ( https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries ), for security and updating purpose, and when the policy change.


And for AUTHORS/CHANGES, the idea of %license at start was to put all in the same directory ( /usr/share/licenses ) and do magic symlink/hardlink to reduce space cf http://www.rpm.org/ticket/116 . 

And https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text say the text of the license is to be there. neither CHANGES nor AUTHORS are.

The related ticket in fpc trac is https://fedorahosted.org/fpc/ticket/411 .

Comment 13 Alexander Ploumistos 2015-04-28 20:36:36 UTC
(In reply to Michael Scherer from comment #12)

Thank you very much for the information, the historical evidence helps put things in perspective (and makes it easier to remember).

Comment 14 Gwyn Ciesla 2015-04-29 10:47:29 UTC
Git done (by process-git-requests).

Comment 15 Fedora Update System 2015-04-29 20:32:38 UTC
python-statsd-2.1.2-2.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/python-statsd-2.1.2-2.fc21

Comment 16 Fedora Update System 2015-05-01 16:37:28 UTC
python-statsd-2.1.2-2.fc21 has been pushed to the Fedora 21 testing repository.

Comment 17 Fedora Update System 2015-05-12 20:48:31 UTC
python-statsd-2.1.2-2.fc21 has been pushed to the Fedora 21 stable repository.

Comment 18 Fedora Update System 2015-06-01 13:13:26 UTC
python-statsd-2.1.2-2.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/python-statsd-2.1.2-2.fc22

Comment 19 Tristan Cacqueray 2015-06-22 17:46:44 UTC
Package Change Request
======================
Package Name: python-statsd
Owners: tdecacqu
New Branches: f20 f21 f22 epel7
InitialCC: misc

The package is missing epel7 repository...

Comment 20 Gwyn Ciesla 2015-06-22 19:22:39 UTC
Git done (by process-git-requests).

Comment 21 Fedora Update System 2015-08-19 08:12:46 UTC
python-statsd-2.1.2-2.fc22 has been pushed to the Fedora 22 stable repository.


Note You need to log in before you can comment on or make changes to this bug.